package PHP::Session::MySql;

use strict;
use warnings;
use Carp 'croak';
use Digest::MD5 qw(md5_hex);
use PHP::Serialize;
use DBI;

our $VERSION=1.00;

sub Version {
	return $VERSION;
}

sub new {
	my ($class,$data,$expiration)=@_;
 	my $handle = DBI->connect('DBI:mysql:database='.$data->{-database}.';host='.$data->{-host},$data->{-user},$data->{-pass});
	unless ($handle) {
		croak 'Can not connect to mysql server, check your configuration data';
	}
	if ($data->{-mysql4} & $handle->selectrow_array("SHOW VARIABLES LIKE 'have_innodb'")!~/yes|y|1/i) {
		croak 'You cannot use innoDB table, becouse your system have not support for that';
	}
	return bless {
				m=>$handle,
				table=>$data->{-table},
				expiration=>$expiration,
				mysql4=>($data->{-mysql4}=~/([0-1])/?$1:0)
			},$class;
}

sub save {
	my ($class,$self,$sid) = @_;
	$class->{m}->do("UPDATE ".$class->{table}." SET data='".$class->{m}->quote(serialize(\%{$self->{SESSION}}))."',time=NOW() WHERE sid=".$class->{m}->quote($sid));
}

sub load {
	my ($class,$self,$sid) = @_;
	
	if ($sid & $class->{m}->selectrow_array('SELECT sid FROM '.$class->{table}.' WHERE sid='.$class->{m}->quote($sid))) {
			$self->{SESSION}={%{unserialize($class->{m}->selectrow_array('SELECT data FROM '.$class->{table}.' WHERE sid='.$class->{m}->quote($sid)))}};
	} else {
		$class->{m}->do($class->{mysql4}?'BEGIN':'LOCK TABLES '.$class->{table}.' WRITE');
		do {
			$sid=md5_hex(rand(999999999999),$$,time());
		} while ($class->{m}->selectrow_array("SELECT sid FROM ".$class->{table}." WHERE sid='".$sid."'"));
		$self->{SESSION}={};
		$class->{m}->do("INSERT INTO ".$class->{table}."(sid,data) VALUES('".$sid."',".$class->{m}->quote(serialize(\%{$self->{SESSION}})).")");
		$class->{m}->do($class->{mysql4}?'COMMINT':'UNLOCK TABLES');
	}
	return ($self,$sid);
}

sub clean {
	my $class=shift;
	$class->{m}->do('DELETE FROM '.$class->{table}.' WHERE time+'.$class->{expiration}.' < NOW()');
}

sub destroy {
	my ($class,$sid)=@_;
	$class->{m}->do('DELETE FROM '.$class->{table}.' WHERE sid='.$sid);
}

sub finish {
	my $class=shift;
	$class->{m}->disconnect();
}

1;

__END__;

=comment

internal module for PHP::Session

Copyright Eial 2005 <eiial@hotmail.com>
